diff --git a/src/backend/parser/parse_target.c b/src/backend/parser/parse_target.c
index b7b82bf..39ed7e0 100644
--- a/src/backend/parser/parse_target.c
+++ b/src/backend/parser/parse_target.c
@@ -33,6 +33,16 @@
 #include "utils/typcache.h"
 
 
+/* Error callback context for transformAssignedExpr */
+typedef struct TransformExprState
+{
+	const char *column_name;
+	const char *relation_name;
+	Oid			expected_type;
+	bool		is_insert;
+} TransformExprState;
+
+
 static void markTargetListOrigin(ParseState *pstate, TargetEntry *tle,
 					 Var *var, int levelsup);
 static Node *transformAssignmentIndirection(ParseState *pstate,
@@ -366,6 +376,34 @@ markTargetListOrigin(ParseState *pstate, TargetEntry *tle,
 
 
 /*
+ *
+ * Error context callback for transformAssignedExpr.
+ *
+ * The argument for the error context must be TransformExprState.
+ */
+static void
+TransformExprCallback(void *arg)
+{
+	TransformExprState *state = (TransformExprState *) arg;
+
+	if (state->is_insert)
+	{
+		errcontext("INSERT \"%s\", column \"%s\", type %s",
+				   state->relation_name,
+				   state->column_name,
+				   format_type_be(state->expected_type));
+	}
+	else
+	{
+		errcontext("UPDATE \"%s\", column \"%s\", type %s",
+				   state->relation_name,
+				   state->column_name,
+				   format_type_be(state->expected_type));
+	}
+}
+
+
+/*
  * transformAssignedExpr()
  *	This is used in INSERT and UPDATE statements only.  It prepares an
  *	expression for assignment to a column of the target table.
@@ -404,6 +442,8 @@ transformAssignedExpr(ParseState *pstate,
 	int32		attrtypmod;
 	Oid			attrcollation;	/* collation of target column */
 	ParseExprKind sv_expr_kind;
+	ErrorContextCallback errcallback;
+	TransformExprState te_state;
 
 	/*
 	 * Save and restore identity of expression type we're parsing.  We must
@@ -425,6 +465,16 @@ transformAssignedExpr(ParseState *pstate,
 	attrtypmod = rd->rd_att->attrs[attrno - 1]->atttypmod;
 	attrcollation = rd->rd_att->attrs[attrno - 1]->attcollation;
 
+	/* Set up callback to fetch more details regarding the error */
+	errcallback.callback = TransformExprCallback;
+	errcallback.arg = (void *) &te_state;
+	errcallback.previous = error_context_stack;
+	error_context_stack = &errcallback;
+	te_state.relation_name = RelationGetRelationName(rd);
+	te_state.column_name = colname;
+	te_state.expected_type = attrtype;
+	te_state.is_insert = pstate->p_is_insert;
+
 	/*
 	 * If the expression is a DEFAULT placeholder, insert the attribute's
 	 * type/typmod/collation into it so that exprType etc will report the
@@ -531,6 +581,9 @@ transformAssignedExpr(ParseState *pstate,
 
 	pstate->p_expr_kind = sv_expr_kind;
 
+	/* Reset error callback */
+	error_context_stack = errcallback.previous;
+
 	return expr;
 }
 
